#ifndef WS_H_INCLUDE
#define WS_H_INCLUDE

#include "ozrp.h"
#include <string>

class wonder_swan {
  std::string sio_name;
  int   sio;
 public: 
  int   key;
  double x;
  double y;
  wonder_swan(const std::string devfile = "/dev/cuaa0");
  ~wonder_swan();
  void	init(void) ;	
  void	send_show_data(const ozrp_show_data_t& data);
  void	send_game_data(const ozrp_game_data_t& data);
  void	send_body_data(const ozrp_body_data_t& data);
  void	send_pointer_command(const int& onoff);
  void	send_exit_command();
  int	recv_data(); 
  int   fd() { return this->sio; }
};

enum {
  KEY_START = 0x002,
  KEY_A  =    0x004,
  KEY_B  =    0x008,
  KEY_X1 =    0x010,
  KEY_X2 =    0x020,
  KEY_X3 =    0x040,
  KEY_X4 =    0x080,
  KEY_Y1 =    0x100,
  KEY_Y2 =    0x200,
  KEY_Y3 =    0x400,
  KEY_Y4 =    0x800,
};

#endif /* WS_H_INCLUDE */
