extern "C" {
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <string.h>
}
#include <cstdio>
#include <iostream.h>

#include <ws.h>

int 
wait_by_select(wonder_swan& ws)
{
  fd_set fds;
  timeval timeout;

  FD_ZERO(&fds);
  FD_SET(ws.fd(), &fds);
  timeout.tv_sec = 0;
  timeout.tv_usec = 1000;
    
  int res = ::select(ws.fd() + 1, &fds, NULL, NULL, &timeout);
  if (res > 0) {
    ws.recv_data();
  } else if (res < 0) {
    perror("select()");
  }
  return res;
}

int
main(int argc, char** argv)
{
  if (argc <= 1) {
    exit(1);
  }

  wonder_swan ws(argv[1]);
  int i;

	


  ws.init();
  while (::wait_by_select(ws) <= 0) {
    ;
  }
  cout << "connect" << endl;
  
  ws.send_pointer_command(1);
  cout << "turn to pointer mode" << endl;

  for (i = 0; i < 1000;) {
    int res;
    if ((res = ::wait_by_select(ws)) > 0) {
      i++;
      ::printf("%04x %10f %10f\n", (unsigned int) ws.key, ws.x, ws.y);
    } 
  }
  
  ws.send_pointer_command(0);
  cout << "turn to controller mode" << endl;

  for (i = 0; i < 100;) {
    if (::wait_by_select(ws) > 0) {
      i++;
      ::printf("%04x\n", (unsigned int) ws.key);
    }
  }

  ws.send_exit_command();
  ws.send_exit_command();
  cout << "shotdown program" << endl;

  return 0;
}


