#include <ozrp_ws.h>
char *mode_str[] = {
  "Unknown        " ,
  
  "Before Kick Off" ,
  "Play On        " ,
  "Time Over      " ,
  
  "My Kick Off    " ,
  "My Kick In     " ,
  "My Free Kick   " ,
  "My Corner Kick " ,
  "My Goal Kick   " ,
  "My Goal        " ,
  "My Catch       " ,

  "Opp Kick Off   " ,
  "Opp Kick In    " ,
  "Opp Free Kick  " ,
  "Opp Corner Kick" ,
  "Opp Goal Kick  " ,
  "Opp Goal       " ,
  "Opp Catch      "
};



char recv_buf[1024];

int pointer_mode;
int pointer_x;
int pointer_y;

extern int end_flag;

void
update_time_info(int time)
{
  static int old_time = 0;
  if (old_time != time) {
    static char buf[8];
    text_store_numeric(buf, 5, 0, time);
    ozrp_put_string(0, 0, buf);
    old_time = time;
  }
}

void
update_score_info(int my_score, int their_score, int  play_mode)
{
  static char buf[11];
  buf[0] = '(';
  text_store_numeric(&(buf[1]), 2, 0, my_score);
  buf[3] = ':';
  text_store_numeric(&(buf[4]), 2, 0, their_score);
  buf[6] = ')';
  buf[7] = '\0';

  ozrp_put_string(0, 6, buf);
  ozrp_put_string(1, 6, mode_str[play_mode]);
}

void
update_stamina_info(int stamina, int stamina_100)
{
  static char buf[18];
  text_store_numeric(buf, 5, 0, stamina);
  buf[5] = '\0';
  /*
  buf[5] = '[';
  text_store_numeric(&(buf[6]), 3, 0, stamina_100);
  buf[9] = '%';
  buf[10] = ']';
  buf[11] = '\0';
  */
  ozrp_put_string(1, 0, buf);
}

void
update_show(char *recv_buf, int size)
{
  int i = 0, j = 0, type, x, y;
  int time = recv_buf[j++] << 7 | recv_buf[j++];
  update_time_info(time);

  sprite_set_location(0, 16 + recv_buf[j++] - 4, recv_buf[j++] - 4);

  for (i = 1; i <= 22; i++) {
    type = recv_buf[j++] & 0x0f;
    x = recv_buf[j++];
    y = recv_buf[j++];

    {
      int plt = 0;

      switch (type) {
      case PT_SELF:
	plt = PLT_SELF;
	break;
      case PT_MEMBER:
	plt = PLT_MEMBER;
	break;
      case PT_ENEMY:
	plt = PLT_ENEMY;
	break;
      case PT_UNKNOWN:
	plt = PLT_UNKNOWN;
	break;
      case PT_UNSEEN:
	break;
      }
      if (plt != 0) {
	sprite_set_char(i, CFM_SPR_UPPER | (plt - 8) * 0x200 | player_fn);
	sprite_set_location(i, 16 + x - 4, y - 4);
      } else {
	sprite_set_location(i, 0, 200);
      }
    }
  }
}

void
update_game(char *recv_buf, int size)
{
  int i = 0;
  int time = recv_buf[i++] << 7 | recv_buf[i++];
  int play_mode = recv_buf[i++];
  int my_score = recv_buf[i++];
  int their_score = recv_buf[i++];

  update_time_info(time);
  update_score_info(my_score, their_score,  play_mode);
}

void
update_body(char *recv_buf, int size)
{
  int i = 0;
  int time = recv_buf[i++] << 7 | recv_buf[i++];
  int stamina = recv_buf[i++] << 7 | recv_buf[i++];
  int stamina_100 = recv_buf[i++] << 7 | recv_buf[i++];
  int effort = recv_buf[i++] << 7 | recv_buf[i++];
  int recovery = recv_buf[i++] << 7 | recv_buf[i++];

  update_time_info(time);
  update_stamina_info(stamina, stamina_100);
}

void far
receive_handler()
{
  if (comm_receive_char() == 0xff) {
    int t = comm_receive_char();
    if (t == PKT_PW_EXIT_CMD) {
      end_flag = 1;
      return;
    } else if (t == PKT_PW_POINTER_CMD) {
      pointer_mode = (comm_receive_char() != 0)? 1: 0;
      if (pointer_mode) {
	sprite_set_location(23, 16 + pointer_x - 4, pointer_y -4);
      } else {
	sprite_set_location(23, 0, 200);  /* ̤γ */
      }
      return;
    } else if (t == PKT_PW_SHOW_DATA ||
	       t == PKT_PW_GAME_DATA ||
	       t == PKT_PW_BODY_DATA) {
      int h = comm_receive_char();
      int l = comm_receive_char();
      int size = (h << 7) | l;
      int n = 0;

      comm_receive_block(recv_buf, size, &n);
      if (size == n) {
	if (t == PKT_PW_SHOW_DATA) {
	  update_show(recv_buf, size);
	}else if (t == PKT_PW_GAME_DATA) {
	  update_game(recv_buf, size);
	}else if (t == PKT_PW_BODY_DATA) {
	  update_body(recv_buf, size);
	}
      }
    }
  }
}

void 
key_check()
{
  static int key;
  int key_tmp = key_press_check() & 0x0ffe;
  int change = 0;
  if (key_tmp != key) {
    key = key_tmp;
    change = 1;
  }
  if (pointer_mode) {
    int f = 0;
    if (key & KEY_Y1) { pointer_y--; f++;}
    if (key & KEY_Y2) { pointer_x++; f++;}
    if (key & KEY_Y3) { pointer_y++; f++;}
    if (key & KEY_Y4) { pointer_x--; f++;}
    if (f) {
      if (pointer_x < 0) { pointer_x = 0; } 
      if (pointer_x > 208) { pointer_x = 208; } 
      if (pointer_y < 0) { pointer_y = 0; } 
      if (pointer_y > 144) { pointer_y = 144; } 
      sprite_set_location(23, 16 + pointer_x - 4, pointer_y -4);
      /*
      comm_send_char(0xff);
      comm_send_char((char) PKT_WP_POINTER);
      comm_send_char((char)(pointer_x & 0xff));
      comm_send_char((char)(pointer_y & 0xff));
      */
    }
  }

  if (change) {
    char h, l;

    h = (key >> 8);
    l = (key & 0x00ff);
    if (pointer_mode) {
      comm_send_char(0xff);
      comm_send_char((char) PKT_WP_POINTER);
      comm_send_char((char)(pointer_x & 0xff));
      comm_send_char((char)(pointer_y & 0xff));
    }
    comm_send_char(0xff);
    comm_send_char((char) PKT_WP_KEYSTATUS);
    comm_send_char(h);
    comm_send_char(l);
  }

  if ((key & (KEY_START | KEY_A)) == (KEY_START | KEY_A)) {
    end_flag = 1;
  }
}


static intvector_t recv_iv;

void 
ozrp_comm_init()
{
  comm_open();
  comm_set_timeout(1,1);
  comm_set_baudrate(COMM_SPEED_38400);

  recv_iv.callback = (void (near *)())FP_OFF(receive_handler);
  recv_iv.cs =  _asm_inline("mov ax, cs");
  recv_iv.ds =  _asm_inline("mov ax, ds");
  
  sys_interrupt_set_hook(SYS_INT_RECEIVEREADY, &recv_iv, NULL);

  comm_send_char(0xff);
  comm_send_char((char) PKT_WP_ACK);
  comm_send_char((char) PKT_WP_ACK);
  comm_send_char((char) PKT_WP_ACK);

  pointer_mode = 0;
  pointer_x = 100;
  pointer_y = 72;
}

void
ozrp_comm_close()
{
  sys_interrupt_reset_hook(SYS_INT_RECEIVEREADY, NULL);

  comm_close();
}
