#include <ozrp_ws.h>


static char font_datas[128][8];

extern unsigned int field_top;
extern unsigned int mode_line1_top;
extern unsigned int mode_line2_top;


void
ozrp_text_init()
{
  static char fdata[8];
  char i;
  int  j, k;
  for (i = 0; i < 0x80; i++) {
    text_get_fontdata(i, fdata);
    for (j = 0; j < 8; j++) {
      font_datas[i][j] = 0;
      for(k = 0; k < 8; k++) {
	font_datas[i][j] |= ((fdata[k] >> (7 - j)) & 1) << k;
      }
    }
  }
}

int
ozrp_put_char(int l, int col, char c)
{
  if (0 <= l && l < 2) {
    int line = (l == 0)? mode_line1_top: mode_line2_top;
    if (0 <= col && col < 18) {
      if (0 <= c && c < 0x80) {
	font_set_monodata(line + col, 1, &(font_datas[c]));
	return 1;
      }
    }
  }
  return 0;
}

void
ozrp_put_string(int l, int col, char *str)
{
  for (;*str != '\0'; str++, col++){
    if (ozrp_put_char(l, col, *str)) {
      continue;
    }
    break;
  }
}

void
text_test()
{
  static char buf[32];
  static char buf2[32] = "OZRP WS";

  ozrp_put_string(0, 0, buf2);
  text_store_numeric(buf, 5, 0, 9999);
  ozrp_put_string(1, 0, buf);
  ozrp_put_string(1, 5, "TATE TEXT TEST");
  /*
  font_set_monodata(field_top, 1, &(font_datas['1']));
  font_set_monodata(field_top+26, 1, &(font_datas['2']));
  font_set_monodata(field_top+26*2, 1, &(font_datas['3']));
  font_set_monodata(field_top+26*17, 1, &(font_datas['4']));
  */
}
